﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace DockingAndMVVM
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		int index = 0;
		ObservableCollection<PaneViewModel> panes;
		public Window1()
		{
			InitializeComponent();

			this.RegenerateData();
		}

		private void RegenerateData()
		{
			group.DataContext = panes = new ObservableCollection<PaneViewModel>(Enumerable.Range(1, 2).Select(i => new PaneViewModel
			{
				Header = string.Format("Pane.{1}.{0}", i, index),
				Content = new PaneContentViewModel { SomeContent = string.Format("Content of Pane.{1}.{0}", i, index) }
			}));
		}

		private void ButtonReset_Click(object sender, RoutedEventArgs e)
		{
			index++;
			this.RegenerateData();
		}

		private void ButtonAdd_Click(object sender, RoutedEventArgs e)
		{
			this.panes.Add(new PaneViewModel
			{
				Header = string.Format("PaneXXXAdd"),
				Content = new PaneContentViewModel { SomeContent = string.Format("Content of PaneXXXAdd") }
			});
		}

		private void ButtonInsert_Click(object sender, RoutedEventArgs e)
		{
			this.panes.Insert(0, new PaneViewModel
			{
				Header = string.Format("PaneXXXInsert"),
				Content = new PaneContentViewModel { SomeContent = string.Format("Content of PaneXXXInsert") }
			});
		}

		private void ButtonDelFirst_Click(object sender, RoutedEventArgs e)
		{
			this.panes.RemoveAt(0);
		}

		private void ButtonDelLast_Click(object sender, RoutedEventArgs e)
		{
			this.panes.Remove(this.panes.Last());
		}


	}
}
